package com.shopee.sandynie.cart.greendao;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.internal.DaoConfig;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;

import com.shopee.sandynie.cart.daoentity.CatBreedEntity;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "CAT_BREED_ENTITY".
*/
public class CatBreedEntityDao extends AbstractDao<CatBreedEntity, Long> {

    public static final String TABLENAME = "CAT_BREED_ENTITY";

    /**
     * Properties of entity CatBreedEntity.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property Page = new Property(0, Long.class, "page", true, "_id");
        public final static Property CatBreedListData = new Property(1, String.class, "catBreedListData", false, "CAT_BREED_LIST_DATA");
    }


    public CatBreedEntityDao(DaoConfig config) {
        super(config);
    }
    
    public CatBreedEntityDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"CAT_BREED_ENTITY\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: page
                "\"CAT_BREED_LIST_DATA\" TEXT);"); // 1: catBreedListData
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"CAT_BREED_ENTITY\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, CatBreedEntity entity) {
        stmt.clearBindings();
 
        Long page = entity.getPage();
        if (page != null) {
            stmt.bindLong(1, page);
        }
 
        String catBreedListData = entity.getCatBreedListData();
        if (catBreedListData != null) {
            stmt.bindString(2, catBreedListData);
        }
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, CatBreedEntity entity) {
        stmt.clearBindings();
 
        Long page = entity.getPage();
        if (page != null) {
            stmt.bindLong(1, page);
        }
 
        String catBreedListData = entity.getCatBreedListData();
        if (catBreedListData != null) {
            stmt.bindString(2, catBreedListData);
        }
    }

    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    @Override
    public CatBreedEntity readEntity(Cursor cursor, int offset) {
        CatBreedEntity entity = new CatBreedEntity( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // page
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1) // catBreedListData
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, CatBreedEntity entity, int offset) {
        entity.setPage(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setCatBreedListData(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
     }
    
    @Override
    protected final Long updateKeyAfterInsert(CatBreedEntity entity, long rowId) {
        entity.setPage(rowId);
        return rowId;
    }
    
    @Override
    public Long getKey(CatBreedEntity entity) {
        if(entity != null) {
            return entity.getPage();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(CatBreedEntity entity) {
        return entity.getPage() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
